require 'dp/parser'

def assert(method, code, output)
  parser = Parser.new
  path = "code.txt"
  open(path, "w") {|f| f.print code }
  parser.load(path)
  sout = parser.send(method).inspect << "\n"
  print sout
  if sout != output
    print output
    print "not "
  end
  print "ok\n"
end

assert(:exception_selector, <<CODE, <<OUTPUT)
E: Exception
CODE
[":", "E", "Exception"]
OUTPUT

assert(:exception_selector, <<CODE, <<OUTPUT)
E: I.Exception
CODE
[":", "E", [".", "I", "Exception"]]
OUTPUT

assert(:exception_selector, <<CODE, <<OUTPUT)
E : 
Exception
CODE
[":", "E", "Exception"]
OUTPUT

assert(:exception_handler, <<CODE, <<OUTPUT)
on E: Exception do ;
CODE
["on", [":", "E", "Exception"], "do", nil]
OUTPUT

assert(:try_stmt, <<CODE, <<OUTPUT)
try
  //
except
  on EZeroDivide do HandleZeroDivide;
  on EOverflow do HandleOverflow;
  on EMathError do HandleMathError;
end;
CODE
nil
OUTPUT

assert(:try_stmt, <<CODE, <<OUTPUT)
try
  //
except
  on EZeroDivide do HandleZeroDivide;
  on EOverflow do HandleOverflow;
  on EMathError do HandleMathError;
else
  HandleAllOthers;
end;
CODE
nil
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
X                     { ϐ }
CODE
"X"
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
@X                    { ϐ̃AhX }
CODE
["@", "X"]
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
15                    { 萔 }
CODE
"15"
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
InterestRate          { ϐ }
CODE
"InterestRate"
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
Calc(X,Y)             { ֐Ăяo }
CODE
["(", "Calc", ["X", "Y"]]
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
X * Y                 { X  Y ̐ }
CODE
["*", "X", "Y"]
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
Z / (1 - Z)           { Z  (1 - Z) ̏ }
CODE
["/", "Z", ["-", "1", "Z"]]
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
X = 1.5               { _^ }
CODE
["=", "X", "1.5"]
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
C in Range1           { _^ }
CODE
["in", "C", "Range1"]
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
not Done              { _^̔ے }
CODE
["not", "Done"]
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
['a','b','c']         { W }
CODE
["[", ["'a'", "'b'", "'c'"]]
OUTPUT

assert(:expr, <<CODE, <<OUTPUT)
Char(48)              { l^LXg }
CODE
["(", "Char", ["48"]]
OUTPUT

